#!/bin/zsh
# (c) Nei <anti.teamidiot.de>

. ./sbd.config.lib.zsh

date

. ./speech.lib.zsh

cookie=/tmp/scanbtn.cookie
recent_call_bit=($cookie(ms-2N))
if [[ $#recent_call_bit -gt 0 ]] || \
    { ! scanimage -n } {
	gt_speech LOST_DEV &
	killall sanebuttonsd
	exit 1
}
touch $cookie

scanimg_norm=($scanimg_cmd $scanimg_opts_dbg)
scanimg_text=($scanimg_cmd $scanimg_opts_text $scanimg_opts_dbg)

temp_file=/tmp/scanbtn.scan.tif

timestamp=$(date +%s%N)

do_scan() {
	echo Scanning...
	if [[ $1 == text ]] {
		scan_cmd=($scanimg_text)
		mode_ext=ocr
	} \
	else {
		scan_cmd=($scanimg_norm)
		mode_ext=img
	}
	$scan_cmd > $temp_file
	mv -f $temp_file $qdir/$timestamp.$mode_ext
	echo finished...
	gt_speech FINISHED &
}

case $1 {
	-0) gt_speech COLOR_IMG &
		do_scan
	;;
	-1) if [[ -s $outdir/Info.txt ]] {
	    	head -4 $outdir/Info.txt | tail -1 | speech_cmd &
	    } \
	    else {
	    	gt_speech DEBUG_MSG &
	    }
	;;
	-2) gt_speech GRAY_IMG &
		do_scan text
	;;
	-3) gt_speech COLLECT &
		touch $qdir/$timestamp.collect
	;;
}
